const dbConnection = require("../db/connection");
const globalFun = require("./globalfuntions.controller");
const { logger_data, logger_msg } = require('../config/utils');

precioMonedaController = {};

let msgLog = [];
let counter = 0;

precioMonedaController.precioMoneda_list = (req, res) => {
    globalFunctions.logger(logger_data(req), 'trace', logger_msg.loading);
    const precioMoneda = req.body;
    const query = "SELECT * FROM precioMoneda;";
    dbConnection.connectionDB.query(query, (error, results) => {
        if (error) {
            globalFunctions.logger(logger_data(req), 'error', logger_msg.noInfo);
            console.error(error);
            const status = globalFunctions.statusMsg(0);
            msgLog.length = 0;
            msgLog.push(status);
            res.json(msgLog);
            msgLog.length = 0;
        } else if (results.length > 0) {
            globalFunctions.logger(logger_data(req), 'info', logger_msg.info);
            res.json(results);
        } else {
            const status = globalFunctions.statusMsg(4);
            globalFunctions.logger(logger_data(req), 'error', status.status_message_description);
            msgLog.length = 0;
            msgLog.push(status);
            res.json(msgLog);
            msgLog.length = 0;
        }
    });
};

precioMonedaController.precioMoneda_detail = (req, res) => {
    globalFunctions.logger(logger_data(req), 'trace', logger_msg.loading);
    const precioMoneda = req.body;
    const query = "SELECT * FROM precioMoneda WHERE idProducto=? LIMIT 1;";
    dbConnection.connectionDB.query(query, [precioMoneda.idProducto], (error, response, results) => {
        if (error) {
            console.error(error);
            const status = globalFunctions.statusMsg(0);
            console.table(status);
            msgLog.length = 0;
            msgLog.push(status);
            res.json(msgLog);
            msgLog.length = 0;
        } else if (response) {
            res.json(response);
        } else {
            const status = globalFunctions.statusMsg(4);
            console.table(status);
            msgLog.length = 0;
            msgLog.push(status);
            res.json(msgLog);
            msgLog.length = 0;
        }
    });
};

precioMonedaController.precioMoneda_create_post = (req, res) => {
    globalFunctions.logger(logger_data(req), 'trace', logger_msg.loading);
    const precioMoneda = req.body;
    const query = "INSERT INTO precioMoneda(idProducto, precio, precioDolar) VALUES(?, ?, ?);";
    if (!precioMoneda) {
        const status = globalFunctions.statusMsg(4);
        msgLog.length = 0;
        msgLog.push(status);
        res.json(msgLog);
        msgLog.length = 0;
    } else {
        dbConnection.connectionDB.beginTransaction((err) => {
            if (err) {
                globalFunctions.logger(logger_data(req), 'error', `${logger_msg.transaction.error} ${err}`);
            } else {
                dbConnection.connectionDB.query(query, [precioMoneda.idProducto, precioMoneda.precio, precioMoneda.precioDolar],
                    (error, response, result) => {
                        if (error) {
                            if (error.code == 'ER_DUP_ENTRY') {
                                dbConnection.connectionDB.rollback(() => {
                                    globalFunctions.logger(logger_data(req), 'error', `${logger_msg.query.rollback} ${error}`);
                                    const status = globalFunctions.statusMsg(6);
                                    msgLog.length = 0;
                                    msgLog.push(status);
                                    res.json(msgLog);
                                    msgLog.length = 0;
                                });
                            } else {
                                dbConnection.connectionDB.rollback(() => {
                                    globalFunctions.logger(logger_data(req), 'error', `${logger_msg.query.rollback} ${error}`);
                                    const status = globalFunctions.statusMsg(0);
                                    msgLog.length = 0;
                                    msgLog.push(status);
                                    res.json(msgLog);
                                    msgLog.length = 0;
                                });
                            }
                        } else if (response) {
                            dbConnection.connectionDB.commit((err) => {
                                if (err) {
                                    dbConnection.connectionDB.rollback(() => {
                                        globalFunctions.logger(logger_data(req), 'error', `${logger_msg.query.rollback} ${err}`);
                                    });
                                } else {
                                    globalFunctions.logger(logger_data(req), 'info', `${logger_msg.info}`);
                                    const status = globalFunctions.statusMsg(1);
                                    msgLog.length = 0;
                                    msgLog.push(status);
                                    res.json(msgLog);
                                    msgLog.length = 0;
                                }
                            });
                        }
                    },
                );
            }
        });
    }
}

precioMonedaController.precioMoneda_update_post = (req, res) => {
    const precioMoneda = req.body;
    const query = "UPDATE precioMoneda SET precio=?, precioDolar=? WHERE idProducto=?;";
    if (!precioMoneda) {
        const status = globalFunctions.statusMsg(4);
        msgLog.length = 0;
        msgLog.push(status);
        res.json(msgLog);
        msgLog.length = 0;
    } else {
        dbConnection.connectionDB.beginTransaction((err) => {
            if (err) {
                globalFunctions.logger(logger_data(req), 'error', `${logger_msg.transaction.error} ${err}`);
            } else {
                dbConnection.connectionDB.query(query, [precioMoneda.precio, precioMoneda.precioDolar, precioMoneda.idProducto],
                    (error, response, result) => {
                        if (error) {
                            dbConnection.connectionDB.rollback(() => {
                                globalFunctions.logger(logger_data(req), 'error', `${logger_msg.query.rollback} ${error}`);
                                const status = globalFunctions.statusMsg(0);
                                msgLog.length = 0;
                                msgLog.push(status);
                                res.json(msgLog);
                                msgLog.length = 0;
                            });
                        } else if (response) {
                            dbConnection.connectionDB.commit((err) => {
                                if (err) {
                                    dbConnection.connectionDB.rollback(() => {
                                        globalFunctions.logger(logger_data(req), 'error', `${logger_msg.query.rollback} ${err}`);
                                    });
                                } else {
                                    globalFunctions.logger(logger_data(req), 'info', `${logger_msg.info}`);
                                    const status = globalFunctions.statusMsg(1);
                                    msgLog.length = 0;
                                    msgLog.push(status);
                                    res.json(msgLog);
                                    msgLog.length = 0;
                                }
                            });
                        }
                    },
                );
            }
        });
    }
}

precioMonedaController.precioMoneda_delete_post = (req, res) => {
    const precioMoneda = req.body;
    if (!precioMoneda) {
        const status = globalFunctions.statusMsg(4);
        msgLog.length = 0;
        msgLog.push(status);
        res.json(msgLog);
        msgLog.length = 0;
    } else {
        const query = "DELETE FROM precioMoneda WHERE idProducto=?";
        dbConnection.connectionDB.beginTransaction((err) => {
            if (err) {
                globalFunctions.logger(logger_data(req), 'error', `${logger_msg.transaction.error} ${err}`);
            } else {
                dbConnection.connectionDB.query(query, [precioMoneda.id, precioMoneda.idEmpresas],
                    (error, response, result) => {
                        if (error) {
                            dbConnection.connectionDB.rollback(() => {
                                globalFunctions.logger(logger_data(req), 'error', `${logger_msg.query.rollback} ${error}`);
                                const status = globalFunctions.statusMsg(0);
                                msgLog.length = 0;
                                msgLog.push(status);
                                res.json(msgLog);
                                msgLog.length = 0;
                            });
                        } else if (response) {
                            dbConnection.connectionDB.commit((err) => {
                                if (err) {
                                    dbConnection.connectionDB.rollback(() => {
                                        globalFunctions.logger(logger_data(req), 'error', `${logger_msg.query.rollback} ${err}`);
                                        const status = globalFunctions.statusMsg(0);
                                        msgLog.length = 0;
                                        msgLog.push(status);
                                        res.json(msgLog);
                                        msgLog.length = 0;
                                    });
                                } else {
                                    globalFunctions.logger(logger_data(req), 'info', `${logger_msg.info}`);
                                    const status = globalFunctions.statusMsg(1);
                                    msgLog.length = 0;
                                    msgLog.push(status);
                                    res.json(msgLog);
                                    msgLog.length = 0;
                                }
                            });
                        } else {
                            const status = globalFunctions.statusMsg(4);
                            msgLog.length = 0;
                            msgLog.push(status);
                            res.json(msgLog);
                            msgLog.length = 0;
                        }
                    },
                );
            }
        });
        // */
    }
}
module.exports.precioMonedaController = precioMonedaController;