const dbConnection = require("../db/connection");

// const readXlsxFile = require("read-excel-file/node");

const fs = require("fs");

const XLSX = require("xlsx");

const globalFun = require("./globalfuntions.controller");

const { logger_data, logger_msg } = require('../config/utils');

global.__basedir = __dirname;

productos_componentesController = {};

let productosMatrix = [];
let msgLog = [];
let counter = 0;

productos_componentesController.loadpage = (req, res) => {
	res.send("API productos Codigos Alternos");
}

productos_componentesController.productos_componentes_list = (req, res) => {
	const query = "SELECT * FROM productosComponentes";
	dbConnection.connectionDB.query(query, (error, results) => {
		if (error) {
			globalFunctions.logger(logger_data(req), 'error', logger_msg.noInfo);
			throw error;
		} else if (results.length > 0) {
			globalFunctions.logger(logger_data(req), 'info', logger_msg.info);
			res.json(results);
		} else {
			const status = globalFunctions.statusMsg(4);
			globalFunctions.logger(logger_data(req), 'error', status.status_message_description);
			msgLog.length = 0;
			msgLog.push(status);
			res.json(msgLog);
			msgLog.length = 0;
		}
	});
};

productos_componentesController.productos_componentes_detail = (req, res) => {
	globalFunctions.logger(logger_data(req), 'trace', logger_msg.metodo);
	const productoC = req.body;
	// const query = "SELECT * FROM productosComponentes WHERE idProductoPrincipal = ?;";
	// const query = "SELECT pc.id, pc.idProductoPrincipal, p.descLarga as idProductos, m.descripcion as idMedidas, pc.costo, pc.unidades, pc.total FROM productosComponentes pc LEFT JOIN productos p ON p.id = pc.idProductos LEFT JOIN medidas m ON m.id = pc.idMedidas WHERE idProductoPrincipal = ?;";
	const query = "SELECT pc.id, pc.idProductoPrincipal, pc.idProductos, p.descLarga as idProductosDescripcion, pc.idMedidas, m.descripcion as idMedidasDescripcion, pc.costo, pc.unidades, pc.total FROM productosComponentes pc LEFT JOIN productos p ON p.id = pc.idProductos LEFT JOIN medidas m ON m.id = pc.idMedidas WHERE idProductoPrincipal = ?;";
	dbConnection.connectionDB.query(query, [productoC.idProductoPrincipal], (error, results) => {
		if (error) {
			globalFunctions.logger(logger_data(req), 'error', logger_msg.noInfo);
			const status = globalFunctions.statusMsg(0);
			msgLog.length = 0;
			msgLog.push(status);
			res.json(msgLog);
			msgLog.length = 0;
		} else if (results.length > 0) {
			res.json(results);
		} else {
			const status = globalFunctions.statusMsg(4);
			console.table(status);
			msgLog.length = 0;
			msgLog.push(status);
			res.json(msgLog);
			msgLog.length = 0;
		}
	});
};

productos_componentesController.productos_componentes_create_post = (req, res) => {
	globalFunctions.logger(logger_data(req), 'trace', logger_msg.metodo);
	const productoC = req.body;
	const query = "INSERT INTO productosComponentes (idProductoPrincipal, idProductos, idMedidas, costo, unidades, total) VALUES(?, ?, ?, ?, ?, ?);";

	if (!productoC) {
		const status = globalFunctions.statusMsg(4);
		msgLog.length = 0;
		msgLog.push(status);
		res.json(msgLog);
		msgLog.length = 0;
	} else {

		if (!productoC.idProductos) {
			const status = globalFunctions.statusMsg(4);
			msgLog.length = 0;
			msgLog.push(status);
			res.json(msgLog);
			msgLog.length = 0;
		} else {
			dbConnection.connectionDB.beginTransaction((err) => {
				if (err) {
					console.error("TRANSACTION ERROR :>> ", err);
				} else {
					dbConnection.connectionDB.query(
						query, [productoC.idProductoPrincipal, productoC.idProductos, productoC.idMedidas, productoC.costo, productoC.unidades, productoC.total],
						(error, response, result) => {
							if (error) {
								if (error.code == 'ER_DUP_ENTRY') {
									dbConnection.connectionDB.rollback(() => {
										console.log("QUERY > ROLLBACK ERROR INSERT productoC :>> ", error);
										const status = globalFunctions.statusMsg(6);
										msgLog.length = 0;
										msgLog.push(status);
										res.json(msgLog);
										msgLog.length = 0;
									});
								} else {
									dbConnection.connectionDB.rollback(() => {
										console.log("QUERY > ROLLBACK ERROR INSERT productoC :>> ", error);
										const status = globalFunctions.statusMsg(0);
										msgLog.length = 0;
										msgLog.push(status);
										res.json(msgLog);
										msgLog.length = 0;
									});
								}

							} else if (response) {
								console.log("QUERY RESULT :>> ");
								console.log(result);
								dbConnection.connectionDB.commit((err) => {
									if (err) {
										dbConnection.connectionDB.rollback(() => {
											console.log(
												"COMMIT ERROR ROLLBACK INSERT productoC :>> ",
												err,
											);
										});
									} else {
										const status = globalFunctions.statusMsg(1);
										msgLog.length = 0;
										msgLog.push(status);
										res.json(msgLog);
										msgLog.length = 0;
									}
								});
							}
						},
					);
				}
			});
		}
	}
}

productos_componentesController.productos_componentes_update_post = (req, res) => {
	globalFunctions.logger(logger_data(req), 'trace', logger_msg.metodo);
	const productoC = req.body;
	const query = "UPDATE productosComponentes SET idProductos=?, idMedidas=?, costo=?, unidades=?, total=? WHERE id=? AND idProductoPrincipal=?;";

	if (!productoC) {
		const status = globalFunctions.statusMsg(4);
		msgLog.length = 0;
		msgLog.push(status);
		res.json(msgLog);
		msgLog.length = 0;
	} else {

		if (!productoC.id) {
			const status = globalFunctions.statusMsg(4);
			msgLog.length = 0;
			msgLog.push(status);
			res.json(msgLog);
			msgLog.length = 0;
		} else {
			dbConnection.connectionDB.beginTransaction((err) => {
				if (err) {
					console.error("TRANSACTION ERROR :>> ", err);
				} else {
					dbConnection.connectionDB.query(
						query, [productoC.idProductos, productoC.idMedidas, productoC.costo, productoC.unidades, productoC.total, productoC.id, productoC.idProductoPrincipal],
						(error, response, result) => {
							if (error) {
								if (error.code == 'ER_DUP_ENTRY') {
									dbConnection.connectionDB.rollback(() => {
										console.log("QUERY > ROLLBACK ERROR INSERT productoC :>> ", error);
										const status = globalFunctions.statusMsg(6);
										msgLog.length = 0;
										msgLog.push(status);
										res.json(msgLog);
										msgLog.length = 0;
									});
								} else {
									dbConnection.connectionDB.rollback(() => {
										console.log("QUERY > ROLLBACK ERROR INSERT productoC :>> ", error);
										const status = globalFunctions.statusMsg(0);
										msgLog.length = 0;
										msgLog.push(status);
										res.json(msgLog);
										msgLog.length = 0;
									});
								}

							} else if (response) {
								console.log("QUERY RESULT :>> ");
								console.log(result);
								dbConnection.connectionDB.commit((err) => {
									if (err) {
										dbConnection.connectionDB.rollback(() => {
											console.log(
												"COMMIT ERROR ROLLBACK INSERT productoC :>> ",
												err,
											);
										});
									} else {
										const status = globalFunctions.statusMsg(1);
										msgLog.length = 0;
										msgLog.push(status);
										res.json(msgLog);
										msgLog.length = 0;
									}
								});
							}
						},
					);
				}
			});
		}
	}
}

productos_componentesController.productos_componentes_delete_post = (req, res) => {
	globalFunctions.logger(logger_data(req), 'trace', logger_msg.metodo);
	const productoC = req.body;
	const query = "DELETE FROM productosComponentes WHERE id = ? AND idProductoPrincipal = ?";

	if (!productoC) {
		const status = globalFunctions.statusMsg(4);
		msgLog.length = 0;
		msgLog.push(status);
		res.json(msgLog);
		msgLog.length = 0;
	} else {

		if (!productoC.id) {
			const status = globalFunctions.statusMsg(4);
			msgLog.length = 0;
			msgLog.push(status);
			res.json(msgLog);
			msgLog.length = 0;
		} else {
			dbConnection.connectionDB.beginTransaction((err) => {
				if (err) {
					console.error("TRANSACTION ERROR :>> ", err);
				} else {
					dbConnection.connectionDB.query(
						query, [productoC.id, productoC.idProductoPrincipal],
						(error, response, result) => {
							if (error) {
								if (error.code == 'ER_DUP_ENTRY') {
									dbConnection.connectionDB.rollback(() => {
										console.log("QUERY > ROLLBACK ERROR INSERT productoC :>> ", error);
										const status = globalFunctions.statusMsg(6);
										msgLog.length = 0;
										msgLog.push(status);
										res.json(msgLog);
										msgLog.length = 0;
									});
								} else {
									dbConnection.connectionDB.rollback(() => {
										console.log("QUERY > ROLLBACK ERROR INSERT productoC :>> ", error);
										const status = globalFunctions.statusMsg(0);
										msgLog.length = 0;
										msgLog.push(status);
										res.json(msgLog);
										msgLog.length = 0;
									});
								}

							} else if (response) {
								console.log("QUERY RESULT :>> ");
								console.log(result);
								dbConnection.connectionDB.commit((err) => {
									if (err) {
										dbConnection.connectionDB.rollback(() => {
											console.log(
												"COMMIT ERROR ROLLBACK INSERT productoC :>> ",
												err,
											);
										});
									} else {
										const status = globalFunctions.statusMsg(1);
										msgLog.length = 0;
										msgLog.push(status);
										res.json(msgLog);
										msgLog.length = 0;
									}
								});
							}
						},
					);
				}
			});
		}
	}
}

module.exports.productos_componentesController = productos_componentesController;